{$G+,X+,A+,N+}
Unit CybUnit;

Interface

var   mainchar:Array[1..4096] of byte;

Procedure MakeXsvga;
Procedure makesvga;
Procedure Bank(b:byte);
Procedure Waitretrace;
Procedure Putpixel(px,py:word;col:byte);
Function Getpixel(px,py:word):byte;
Function escpressed:boolean;
Procedure WrSVGA(kx,ky,kar,col:byte);
Procedure WrStr(mx,ny:byte;text:string;color:byte);
Procedure ClsSVGA;
Procedure GetChar(var scan,kar:byte);
Function windows:boolean;
Procedure Drawline(x1,y1,x2,y2:word;col:byte);
Procedure Putx(x,y:word;c:byte);
Function Getx(x,y:word):byte;
Procedure SputX(x,y:word;plane,c:byte);
Procedure FillXsvga(start,length:word;c:byte);
Procedure Hlinex(y:word;c:byte);
Procedure Vlinex(x:word;c:byte);
Procedure Dlinex(x1,y1,x2,y2:word;col:byte);
Procedure Switch;

Implementation
 var z:word;
     bnk,sw:byte;

 procedure makeXsvga;assembler;
 asm
 {set 640x400x256}
 mov ah,4fh
 mov al,02
 mov bx,0100h
 int 10h
 {Disable chain-4 mode}
 mov dx,03c4h
 mov ax,0604h
 out dx,ax
 {Disable word-mode}
 mov dx,03d4h
 mov ax,0E317h
 out dx,ax
 {Disable doubleword-mode}
 mov dx,03d4h
 mov ax,0014h
 out dx,ax
 {clear whole vga-mem-stuff}
 mov dx,03c4h
 mov ax,0f02h
 out dx,ax

 mov ax,0A000h
 mov es,ax
 mov si,0
 mov ax,0
 mov cx,0
 dec cx
 rep stosb
 end;

 procedure makesvga;assembler;
 asm
 mov ah,4Fh
 mov al,02
 mov bx,0100h
 int 10h
 end;

 Procedure Bank(b:byte);assembler;
 asm
 mov ah,4Fh
 mov al,05
 mov bx,0
 mov dl,b
 mov dh,0
 int 10h
 mov bnk,dl
 end;

 Procedure waitretrace;assembler;
 asm
 push dx
 push ax
 mov dx,03dah
 @bra1:
 in  al,dx
 and al,8
 jnz @bra1
 @bra2:
 in  al,dx
 and al,8
 jz @bra2
 pop ax
 pop dx
 end;

Procedure Putpixel(px,py:word;col:byte);assembler;
asm
mov cx,px
clc
mov ax,640
mov bx,py
mul bx
add ax,cx
adc dl,0
mov bl,bnk
cmp bl,dl
je @nobankset

push ax
mov ah,4Fh
mov al,05h
mov bx,0
int 10h
mov bnk,dl
pop ax

@nobankset:
mov bx,ax
mov ax,0A000h
mov es,ax
mov al,col
mov es:[bx],al
end;

Function Getpixel(px,py:word):byte;
var t:byte;
begin
asm
mov cx,px
mov bx,py
mov ax,640
mul bx
add ax,cx
adc dx,0
mov bl,bnk
cmp bl,dl
je @nobankset

push ax
mov ah,4Fh
mov al,05h
mov bx,0
int 10h
mov bnk,dl
pop ax

@nobankset:
mov bx,ax
mov ax,0A000h
mov es,ax
mov al,es:[bx]
mov t,al
end;
Getpixel:=t;
end;

FUNCTION escpressed:boolean;
 var x:boolean;
 begin
 x:=false;
 asm
 in al,60h
 cmp al,1
 jnz @weg
 mov x,1
 @weg:
 end;
 escpressed:=x
end;

Procedure WrSVGA(kx,ky,kar,col:byte);
var chb:byte;
    Ofset:word;
    xpxl,ypxl:word;
    d,g:byte;
    setit:boolean;
begin
ofset:=kar*16;
ypxl:=ky*16;
xpxl:=kx*8;
for d:=0 to 15 do
 begin
 chb:=mainchar[ofset+d];
   for g:=0 to 7 do
    begin
     asm
     clc
     mov setit,0
     shl chb,1
     jnc @weg
     mov setit,1
     @weg:
     end;
    if setit then
     Putpixel(xpxl+g,ypxl+d,col)
    else
     Putpixel(xpxl+g,ypxl+d,0)
    end
 end
end;

Procedure WrStr(mx,ny:byte;text:string;color:byte);
var z:byte;
begin
dec(mx);
for z:=1 to Length(text) do
 begin
 WrSvga(mx+z,ny,Ord(text[z]),color);
 end
end;

Procedure ClsSVGA;
var x:word;
    a:byte;
begin
for a:=0 to 5 do
  begin
  Bank(a);
  for x:=0 to 65535 do
     mem[$0A000:x]:=0;
  end;
end;

Procedure GetChar(var scan,kar:byte);
var x,y:byte;
begin
x:=0;
y:=0;
asm
mov ah,11h
int 16h

jz @gaweg
mov ah,10h
int 16h
mov x,ah
mov y,al
@gaweg:
end;
scan:=x;
kar:=y;
end;

Function windows:boolean;
var t:boolean;
begin
asm
mov ax,1600h
int 2Fh
cmp al,0
jz  @nowin
mov t,1
jmp @toend
@nowin:
 mov t,0
@toend:
end;
windows:=t;
end;

Procedure Drawline(x1,y1,x2,y2:word;col:byte);assembler;
asm
{trekt een lijn van (ax, bx) naar (cx, dx)}
  mov al,col
  mov byte ptr @goss,al
  mov ax,x1
  mov bx,y1
  mov cx,x2
  mov dx,y2
  jmp @lop
@goss: dw 0

@lop:
  push bp
  push ax                      {;x0 en                                   }
  push bx                      {;y0 bewaren                              }
  mov bx,4340h                 {;voorbereiding zelfstandig wijzigen      }
  sub cx,ax                    {;deltax berekenen                        }
  jns @deltax_ok               {;negatief?                               }
  neg cx                       {;ja, dan teken deltax inverteren         }
  mov bl,48h                   {;en dec ax ipv inc ax                    }
@deltax_ok:
  mov bp,sp                    {;adres van y1 op de stack                }
  sub dx,ss:[bp]               {;deltay berekenen                        }
  jns @deltay_ok               {;negatief?                               }
  neg dx                       {;ja, dan teken deltay inverteren         }
  mov bh,4bh                   {;en dec bx ipv inc bx                    }
@deltay_ok:
  mov si,dx                    {;deltay en                               }
  or si,cx                     {;deltax = 0?                             }
  jne @ok
  add sp,6                     {;dan ax, bx en bp van de stack halen en sluiten}
  ret
@ok:
  mov word ptr cs:@dist_pos,bx  {;dec/inc ax/bx naar doel schrijven       }
  cmp cx,dx                    {;deltax >= deltay ?                      }
  jge @deltax_grootte
  xchg cx,dx                   {;nee, dan deltax en deltay verwisselen   }
  mov bl,90h                   {;en inc ax ongedaan maken                }
  jmp @constanten
@deltax_grootte:
  mov bh,90h                   {;anders inc bx ongedaan maken            }
@constanten:
  mov word ptr cs:@dist_neg,bx         {;dec/inc ax/bx naar doel schrijven       }
  shl dx,1                     {;add_2 berekenen                         }
  mov di,dx                    {;in di bewaren                           }
  sub dx,cx                    {;start-dist berekenen                    }
  mov bp,dx                    {;en in bp bewaren                        }
  mov si,bp                    {;add_1 berekenen                         }
  sub si,cx                    {;en in si bewaren                        }
  pop bx                       {;opgeslagen waarden x0 en y0 terughalen  }
  pop ax
@loop_p:
  pusha
  mov cx,ax                    {ax = x-waarde}
  clc                          {bx = y-waarde}
  mov ax,bx
  mov bx,640
  mul bx
  add ax,cx
  adc dl,0
  mov bl,bnk
  cmp bl,dl
  je @nobankset

  push ax
  mov ah,4Fh
  mov al,05h
  mov bx,0
  int 10h
  mov bnk,dl
  pop ax

  @nobankset:
  mov bx,ax
  mov ax,0A000h
  mov es,ax
  mov al,byte ptr @goss
  mov byte ptr es:[bx],al

  popa
  or bp,bp                     {;dist positief?                          }
  jns @dist_pos
@dist_neg:
  inc ax                       {;x ophogen (evtl zelfstandig wijzigen)   }
  inc bx                       {;y ophogen (evtl zelfstandig wijzigen)   }
  add bp,di                    {;dist actualiseren                       }
  loop @loop_p                 {;volgende punt                           }
  jmp @ready                   {;spring naar ready                       }
@dist_pos:
  inc ax                       {;x ophogen (evtl zelfstandig wijzigen)  }
  inc bx                       {;y ophogen (evtl zelfstandig wijzigen)  }
  add bp,si                    {;dist actualiseren                      }
  loop @loop_p                 {;volgende punt                          }
@ready:
  pop bp
end;

procedure putx(x,y:word;c:byte);assembler;
asm
mov dx,03c4h
mov al,02
out dx,al
mov cx,x
and cx,3
mov al,1
shl al,cl
mov dx,03c5h
out dx,al

mov ax,y
mov bx,160
mul bx
mov bx,x
shr bx,2
add bx,ax
mov ax,0A000h
mov es,ax
mov al,c
mov es:[bx],al
end;

Function Getx(x,y:word):byte;assembler;
asm
mov dx,03ceh
mov al,4
mov bx,x
and bx,3
mov ah,bl
out dx,ax

mov ax,0A000h
mov es,ax
mov ax,y
mov bx,160
mul bx
mov bx,x
shr bx,2
add bx,ax
mov al,es:[bx]
mov byte ptr getx,al
end;

procedure sputx(x,y:word;plane,c:byte);assembler;
asm
mov dx,03c4h
mov al,02
out dx,al
inc dx
mov al,plane
out dx,al

mov ax,y
mov bx,160
mul bx
mov bx,x
shr bx,2
add bx,ax
mov ax,0A000h
mov es,ax
mov al,c
mov es:[bx],al
end;

Procedure FillXsvga(start,length:word;c:byte);assembler;
asm
mov dx,03c4h
mov al,02
mov ah,15
out dx,ax

mov ax,0A000h
mov es,ax
mov di,start
mov al,c
mov cx,length
rep stosb
end;

Procedure Hlinex(y:word;c:byte);assembler;
asm
mov dx,03c4h
mov al,02
mov ah,15
out dx,ax
mov ax,y
mov bx,160
mul bx
mov di,ax
mov cx,160
mov ax,0A000h
mov es,ax
mov al,c
rep stosb
end;

Procedure Vlinex(x:word;c:byte);assembler;
asm
mov ax,x
and ax,3
mov ah,1
mov cl,al
shl ah,cl
mov dx,03c4h
mov al,02
out dx,ax
mov bx,x
shr bx,2
mov cx,400
mov ax,0A000h
mov es,ax
mov al,c
@newpoint:
mov es:[bx],al
add bx,160
loop @newpoint
end;

Procedure Dlinex(x1,y1,x2,y2:word;col:byte);assembler;
asm
{trekt een lijn van (ax, bx) naar (cx, dx)}
  mov al,col
  mov byte ptr @goss,al
  mov ax,x1
  mov bx,y1
  mov cx,x2
  mov dx,y2
  jmp @lop
@goss: dw 0

@lop:
  push bp
  push ax                      {;x0 en                                   }
  push bx                      {;y0 bewaren                              }
  mov bx,4340h                 {;voorbereiding zelfstandig wijzigen      }
  sub cx,ax                    {;deltax berekenen                        }
  jns @deltax_ok               {;negatief?                               }
  neg cx                       {;ja, dan teken deltax inverteren         }
  mov bl,48h                   {;en dec ax ipv inc ax                    }
@deltax_ok:
  mov bp,sp                    {;adres van y1 op de stack                }
  sub dx,ss:[bp]               {;deltay berekenen                        }
  jns @deltay_ok               {;negatief?                               }
  neg dx                       {;ja, dan teken deltay inverteren         }
  mov bh,4bh                   {;en dec bx ipv inc bx                    }
@deltay_ok:
  mov si,dx                    {;deltay en                               }
  or si,cx                     {;deltax = 0?                             }
  jne @ok
  add sp,6                     {;dan ax, bx en bp van de stack halen en sluiten}
  ret
@ok:
  mov word ptr cs:@dist_pos,bx  {;dec/inc ax/bx naar doel schrijven       }
  cmp cx,dx                    {;deltax >= deltay ?                      }
  jge @deltax_grootte
  xchg cx,dx                   {;nee, dan deltax en deltay verwisselen   }
  mov bl,90h                   {;en inc ax ongedaan maken                }
  jmp @constanten
@deltax_grootte:
  mov bh,90h                   {;anders inc bx ongedaan maken            }
@constanten:
  mov word ptr cs:@dist_neg,bx         {;dec/inc ax/bx naar doel schrijven       }
  shl dx,1                     {;add_2 berekenen                         }
  mov di,dx                    {;in di bewaren                           }
  sub dx,cx                    {;start-dist berekenen                    }
  mov bp,dx                    {;en in bp bewaren                        }
  mov si,bp                    {;add_1 berekenen                         }
  sub si,cx                    {;en in si bewaren                        }
  pop bx                       {;opgeslagen waarden x0 en y0 terughalen  }
  pop ax
@loop_p:
  push ax
  push bx
  push cx
  push dx
  push si
  push di
  push es
                               {ax = x-waarde}
                               {bx = y-waarde}
  mov cx,ax
  mov si,ax
  mov di,bx

  mov dx,03c4h
  mov al,02
  and cx,3
  mov ah,1
  shl ah,cl
  out dx,ax

  mov ax,di
  shl ax,7
  shl di,5
  add ax,di
  mov bx,si
  shr bx,2
  add bx,ax
  mov ax,0A000h
  mov es,ax
  mov al,byte ptr @goss
  mov es:[bx],al

  pop es
  pop di
  pop si
  pop dx
  pop cx
  pop bx
  pop ax
  or bp,bp                     {;dist positief?                          }
  jns @dist_pos
@dist_neg:
  inc ax                       {;x ophogen (evtl zelfstandig wijzigen)   }
  inc bx                       {;y ophogen (evtl zelfstandig wijzigen)   }
  add bp,di                    {;dist actualiseren                       }
  loop @loop_p                 {;volgende punt                           }
  jmp @ready                   {;spring naar ready                       }
@dist_pos:
  inc ax                       {;x ophogen (evtl zelfstandig wijzigen)  }
  inc bx                       {;y ophogen (evtl zelfstandig wijzigen)  }
  add bp,si                    {;dist actualiseren                      }
  loop @loop_p                 {;volgende punt                          }
@ready:
  pop bp
end;

procedure switch;assembler;
asm
cli
mov al,byte ptr sw
or al,al
jz @bank0
mov dx,03d4h
mov al,0dh
mov ah,060h
out dx,ax
mov al,0ch
mov ah,0ffh
out dx,ax
mov sw,0
jmp @end_switch
@bank0:
mov dx,03d4h
mov al,0dh
mov ah,0
out dx,ax
mov al,0ch
mov ah,0
out dx,ax
mov sw,1
@end_switch:
sti
end;

begin
sw:=1;
bnk:=10;
end.